- name: Prechecks for Praefect GCP resources
  hosts: localhost
  gather_facts: false

  tasks:
    - name: Get Backends
      command: 'gcloud compute backend-services list --filter="{{ backend_name }}" --project={{ project }}'
      register: backend_services
      changed_when: false
      failed_when:
        - "backend_name not in backend_services.stdout"
    - debug: var=backend_services.stdout_lines

    - name: Check Instance Count in Instance Groups
      shell: 'gcloud compute instance-groups list --filter="{{ instance_group_prefix }}" --project={{ project }} --format="value(INSTANCES)" | jq -s "add"'
      register: instances_in_instance_groups
      changed_when: false
      failed_when:
        - instances_in_instance_groups.stdout != expected_instances

    - name: Check Backend Healthcheck Status
      command: 'gcloud compute backend-services get-health {{ backend_name }} --project={{ project }} --region={{ region }} --format="value(status.healthStatus.healthState)"'
      register: backend_healthcheck_status
      changed_when: false
      failed_when:
        - "'UNHEALTHY' in backend_healthcheck_status.stdout"

    - name: Get instances
      command: 'gcloud compute instance-groups list-instances {{ instance_name_prefix }}{{ item }} --zone={{ item }} --project={{ project }}'
      register: instances
      changed_when: false
      loop: "{{ zones }}"
    - debug:
        msg: "{% for instance in instances.results %}{% if instance['stdout_lines']|length > 1 %} {{ instance['stdout_lines'][1] }} {% endif %} {% endfor %}"
